/*
 * GrammarAccess.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#include "GrammarAccess.h"
#include "settings/GrammarSettings.h"

namespace dataAccess {

std::string GrammarAccess::access ( const std::string & component ) {
	GrammarSettings::Settings settings = dataAccess::GrammarSettings::fromString ( component );

	if ( settings == GrammarSettings::Settings::NONTERMINALS )
		return "grammar::NonterminalAlphabet";

	if ( settings == GrammarSettings::Settings::TERMINALS )
		return "grammar::TerminalAlphabet";

	if ( settings == GrammarSettings::Settings::INITIAL_SYMBOLS )
		return "grammar::InitialSymbol";

	if ( settings == GrammarSettings::Settings::RULES )
		return "grammar::Rules";

	throw exception::CommonException ( "Component not available" );
}

} /* namespace dataAccess */
