/*
 * StringAccess.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#include "StringAccess.h"
#include "settings/StringSettings.h"

namespace dataAccess {

std::string StringAccess::access ( const std::string & component ) {
	StringSettings::Settings settings = dataAccess::StringSettings::fromString ( component );

	if ( settings == StringSettings::Settings::ALPHABET )
		return "string::GeneralAlphabet";

	if ( settings == StringSettings::Settings::CONTENT )
		return "string::Content";

	throw exception::CommonException ( "Component not available" );
}

} /* namespace dataAccess */
