/*
 * ObjectFactory.cpp
 *
 *  Created on: Mar 16, 2018
 *      Author: Jan Travnicek
 */

#include "ObjectFactory.h"
#include <primitive/Bool.h>
#include <primitive/Character.h>
#include <primitive/Double.h>
#include <primitive/Integer.h>
#include <primitive/String.h>
#include <primitive/Unsigned.h>

namespace object {

Object ObjectFactory::make ( bool boolean ) {
	return Object ( primitive::Bool ( boolean ) );
}

Object ObjectFactory::make ( char character ) {
	return Object ( primitive::Character ( character ) );
}

Object ObjectFactory::make ( double number ) {
	return Object ( primitive::Double ( number ) );
}

Object ObjectFactory::make ( int number ) {
	return Object ( primitive::Integer ( number ) );
}

Object ObjectFactory::make ( std::string string ) {
	return Object ( primitive::String ( std::move ( string ) ) );
}

Object ObjectFactory::make ( const char * string ) {
	return make ( ( std::string ) string );
}

Object ObjectFactory::make ( unsigned number ) {
	return Object ( primitive::Unsigned ( number ) );
}

} /* namespace object */
