/*
 * Double.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "Double.h"
#include <registration/ValuePrinterRegistration.hpp>

namespace primitive {

Double::Double(double data) : m_data(data) {

}

PrimitiveBase* Double::clone ( ) const & {
	return new Double(*this);
}

PrimitiveBase* Double::clone() && {
	return new Double(std::move(*this));
}

double Double::getData() const {
	return m_data;
}

Double::operator double ( ) const {
	return m_data;
}

void Double::setData(double data) {
	this->m_data = data;
}

int Double::compare(const Double& other) const {
	if ( m_data < other.m_data )
		return -1;
	else if ( m_data > other.m_data )
		return 1;
	else
		return 0;
}

void Double::operator>>(std::ostream& out) const {
	out << "(Double " << m_data << ")";
}

Double::operator std::string() const {
	return ext::to_string(m_data);
}

PrimitiveBase * Double::inc() && {
	m_data += 1; // TODO fix this
	return this;
}

} /* namespace primitive */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < primitive::Double > ( );

} /* namespace */
