/*
 * Primitive.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#include "Primitive.h"
#include "Integer.h"
#include "Character.h"
#include "String.h"
#include "Unsigned.h"
#include "Bool.h"

namespace primitive {

void Primitive::inc ( ) {
	this->operator ++ ( );
}

Primitive::Primitive ( int number ) : base::WrapperBase < PrimitiveBase > ( Integer { number } ) {
}

Primitive::Primitive ( char character ) : base::WrapperBase < PrimitiveBase > ( Character { character } ) {
}

Primitive::Primitive ( const char * string ) : Primitive ( ( std::string ) string ) {
}

Primitive::Primitive ( std::string string ) : base::WrapperBase < PrimitiveBase > ( String ( std::move ( string ) ) ) {
}

Primitive::Primitive ( unsigned number ) : base::WrapperBase < PrimitiveBase > ( Unsigned ( number ) ) {
}

Primitive::Primitive ( bool value ) : base::WrapperBase < PrimitiveBase > ( Bool ( value ) ) {
}

} /* namespace primitive */
