/*
 * String.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "String.h"
#include <registration/ValuePrinterRegistration.hpp>

namespace primitive {

String::String(std::string data) : m_data(std::move(data)) {

}

String::String(const char* data) : String((std::string) data) {

}

PrimitiveBase* String::clone ( ) const & {
	return new String(*this);
}

PrimitiveBase* String::clone() && {
	return new String(std::move(*this));
}

const std::string & String::getData ( ) const & {
	return m_data;
}

std::string && String::getData ( ) && {
	return std::move ( m_data );
}

void String::setData ( std::string data ) {
	m_data = std::move ( data );
}

int String::compare(const String& other) const {
	return m_data.compare(other.m_data);
}

void String::operator>>(std::ostream& out) const {
	out << "(String " << m_data << ")";
}

String::operator std::string() const {
	return m_data;
}

PrimitiveBase * String::inc() && {
	m_data.push_back('\'');
	return NULL;
}

} /* namespace primitive */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < primitive::String > ( );

} /* namespace */
