/*
 * UnsignedLong.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "UnsignedLong.h"
#include <registration/ValuePrinterRegistration.hpp>

namespace primitive {

UnsignedLong::UnsignedLong(unsigned long data) : m_data(data) {

}

PrimitiveBase* UnsignedLong::clone ( ) const & {
	return new UnsignedLong(*this);
}

PrimitiveBase* UnsignedLong::clone() && {
	return new UnsignedLong(std::move(*this));
}

unsigned long UnsignedLong::getData() const {
	return m_data;
}

UnsignedLong::operator unsigned long ( ) const {
	return m_data;
}

void UnsignedLong::setData(unsigned long data) {
	this->m_data = data;
}

int UnsignedLong::compare(const UnsignedLong& other) const {
	return m_data - other.m_data;
}

void UnsignedLong::operator>>(std::ostream& out) const {
	out << "(UnsignedLong " << m_data << ")";
}

UnsignedLong::operator std::string() const {
	return ext::to_string(m_data);
}

PrimitiveBase * UnsignedLong::inc() && {
	m_data++;
	return NULL;
}

} /* namespace primitive */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < primitive::UnsignedLong > ( );

} /* namespace */
