/*
 * BarSymbol.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Stepan Plachy
 */

#include "BarSymbol.h"

#include <object/Object.h>
#include <object/UniqueObject.h>

#include <registration/ValuePrinterRegistration.hpp>

namespace alphabet {

BarSymbol::BarSymbol() {

}

SymbolBase* BarSymbol::clone ( ) const & {
	return new BarSymbol(*this);
}

SymbolBase* BarSymbol::clone() && {
	return new BarSymbol(std::move(*this));
}

int BarSymbol::compare(const BarSymbol&) const {
	return 0;
}

void BarSymbol::operator>>(std::ostream& out) const {
	out << "(Bar symbol)";
}

BarSymbol::operator std::string () const {
	return BarSymbol::instance < std::string > ( );
}

object::ObjectBase * BarSymbol::inc ( ) && {
	return new object::UniqueObject ( object::Object ( std::move ( * this ) ), primitive::Integer ( 0 ) );
}

} /* namespace alphabet */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alphabet::BarSymbol > ( );

} /* namespace */
