/*
 * EndSymbol.cpp
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#include "EndSymbol.h"

#include <object/Object.h>
#include <object/UniqueObject.h>

#include <registration/ValuePrinterRegistration.hpp>

namespace alphabet {

EndSymbol::EndSymbol() {

}

SymbolBase* EndSymbol::clone ( ) const & {
	return new EndSymbol(*this);
}

SymbolBase* EndSymbol::clone() && {
	return new EndSymbol(std::move(*this));
}

int EndSymbol::compare(const EndSymbol&) const {
	return 0;
}

void EndSymbol::operator>>(std::ostream& out) const {
	out << "(EndSymbol)";
}

EndSymbol::operator std::string () const {
	return EndSymbol::instance < std::string > ( );
}

object::ObjectBase * EndSymbol::inc ( ) && {
	return new object::UniqueObject ( object::Object ( std::move ( * this ) ), primitive::Integer ( 0 ) );
}

} /* namespace alphabet */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alphabet::EndSymbol > ( );

} /* namespace */
