/*
 * StartSymbol.cpp
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#include "StartSymbol.h"

#include <object/Object.h>
#include <object/UniqueObject.h>

#include <registration/ValuePrinterRegistration.hpp>

namespace alphabet {

StartSymbol::StartSymbol() {

}

SymbolBase* StartSymbol::clone ( ) const & {
	return new StartSymbol(*this);
}

SymbolBase* StartSymbol::clone() && {
	return new StartSymbol(std::move(*this));
}

int StartSymbol::compare(const StartSymbol&) const {
	return 0;
}

void StartSymbol::operator>>(std::ostream& out) const {
	out << "(StartSymbol)";
}

StartSymbol::operator std::string () const {
	return StartSymbol::instance < std::string > ( );
}

object::ObjectBase * StartSymbol::inc ( ) && {
	return new object::UniqueObject ( object::Object ( std::move ( * this ) ), primitive::Integer ( 0 ) );
}

} /* namespace alphabet */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alphabet::StartSymbol > ( );

} /* namespace */
