/*
 * AutomatonBase.h
 *
 * This file is part of Algorithms library toolkit.
 * Copyright (C) 2017 Jan Travnicek (jan.travnicek@fit.cvut.cz)

 * Algorithms library toolkit is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * Algorithms library toolkit is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Algorithms library toolkit.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef AUTOMATON_BASE_H_
#define AUTOMATON_BASE_H_

#include <object/ObjectBase.h>

namespace automaton {

/**
 * \brief Represents base for a concrete automaton type.
 */
class AutomatonBase : public object::ObjectBase {
public:
	/**
	 * @copydoc ObjectBase::clone ( ) const &
	 */
	virtual AutomatonBase * clone ( ) const & override = 0;

	/**
	 * @copydoc ObjectBase::clone ( ) &&
	 */
	virtual AutomatonBase * clone() && override = 0;
};

} /* namespace automaton */

#endif /* AUTOMATON_BASE_H_ */
