/*
 * FailStateLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "FailStateLabel.h"

#include <object/Object.h>
#include <object/UniqueObject.h>

#include <registration/ValuePrinterRegistration.hpp>

namespace label {

FailStateLabel::FailStateLabel() {

}

LabelBase* FailStateLabel::clone ( ) const & {
	return new FailStateLabel(*this);
}

LabelBase* FailStateLabel::clone() && {
	return new FailStateLabel(std::move(*this));
}

int FailStateLabel::compare(const FailStateLabel&) const {
	return 0;
}

void FailStateLabel::operator>>(std::ostream& out) const {
	out << "(FailStateLabel)";
}

FailStateLabel::operator std::string() const {
	return FailStateLabel::instance < std::string > ( );
}

object::ObjectBase * FailStateLabel::inc ( ) && {
	return new object::UniqueObject ( object::Object ( std::move ( * this ) ), primitive::Integer ( 0 ) );
}

} /* namespace label */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < label::FailStateLabel > ( );

} /* namespace */
