/*
 * InitialStateLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "InitialStateLabel.h"

#include <object/Object.h>
#include <object/UniqueObject.h>

#include <registration/ValuePrinterRegistration.hpp>

namespace label {

InitialStateLabel::InitialStateLabel() {

}

LabelBase* InitialStateLabel::clone ( ) const & {
	return new InitialStateLabel(*this);
}

LabelBase* InitialStateLabel::clone() && {
	return new InitialStateLabel(std::move(*this));
}

int InitialStateLabel::compare(const InitialStateLabel&) const {
	return 0;
}

void InitialStateLabel::operator>>(std::ostream& out) const {
	out << "(InitialStateLabel)";
}

InitialStateLabel::operator std::string() const {
	return InitialStateLabel::instance < std::string > ( );
}

object::ObjectBase * InitialStateLabel::inc ( ) && {
	return new object::UniqueObject ( object::Object ( std::move ( * this ) ), primitive::Integer ( 0 ) );
}

} /* namespace label */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < label::InitialStateLabel > ( );

} /* namespace */
