/*
 * FailStateLabel.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "FailStateLabel.h"
#include <label/Label.h>
#include <object/Object.h>

#include <registration/XmlRegistration.hpp>

namespace core {

label::FailStateLabel xmlApi < label::FailStateLabel >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return label::FailStateLabel ( );
}

bool xmlApi < label::FailStateLabel >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < label::FailStateLabel >::xmlTagName ( ) {
	static std::string xmlTagName = "FailStateLabel";

	return xmlTagName;
}

void xmlApi < label::FailStateLabel >::compose ( ext::deque < sax::Token > & output, const label::FailStateLabel & ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

} /* namespace core */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < label::FailStateLabel > ( );
static auto xmlRead = registration::XmlReaderRegister < label::FailStateLabel > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < label::Label, label::FailStateLabel > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, label::FailStateLabel > ( );

} /* namespace */
