/*
 * String.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_H_
#define STRING_H_

#include <base/WrapperBase.hpp>
#include "StringBase.h"

#include <alib/set>
#include <alib/vector>
#include <common/DefaultSymbolType.h>
#include <object/ObjectFactory.h>

#include "LinearString.h"

namespace string {

/**
 * Wrapper around strings.
 */
class String : public base::WrapperBase < StringBase > {
	using base::WrapperBase < StringBase >::WrapperBase;

};

template < class SymbolType >
string::String stringFrom ( const SymbolType & symbol ) {
	return string::String { string::LinearString < DefaultSymbolType > { ext::vector < DefaultSymbolType > { object::ObjectFactory::make ( symbol ) } } };
}

string::String stringFrom ( const std::string & str );

string::String stringFrom ( const char * str );

template < class SymbolType >
string::String stringFrom ( const ext::vector < SymbolType > & str ) {
	return string::String { core::normalize < string::LinearString < SymbolType > >::eval ( string::LinearString < SymbolType > { str } ) };
}


} /* namespace string */

#endif /* STRING_H_ */
