/*
 * DataType.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "DataType.h"
#include <primitive/xml/Integer.h>
#include <object/Object.h>

#include <registration/XmlRegistration.hpp>

namespace core {

DataType xmlApi < DataType >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	int value = xmlApi < int >::parse ( input );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return DataType ( value );
}

bool xmlApi < DataType >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < DataType >::xmlTagName ( ) {
	static std::string xmlTagName = "DataType";
	return xmlTagName;
}

void xmlApi < DataType >::compose ( ext::deque < sax::Token > & output, const DataType & data ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT);
	xmlApi < int >::compose ( output, data.getA ( ) );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

} /* namespace core */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < DataType > ( );
static auto xmlRead = registration::XmlReaderRegister < DataType > ( );

} /* namespace */
