#include "MapTest.h"
#include <alib/map>
#include <alib/algorithm>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( MapTest, "bits" );
CPPUNIT_TEST_SUITE_REGISTRATION( MapTest );

void MapTest::setUp() {
}

void MapTest::tearDown() {
}

void MapTest::test3() {
	int moves;
	int copies;

	ext::map<MapTest::Moveable, MapTest::Moveable> map;
	map.insert ( std::make_pair ( MapTest::Moveable(moves, copies ), MapTest::Moveable(moves, copies)) );
	ext::map<MapTest::Moveable, MapTest::Moveable> map2;

	for( std::pair < Moveable, Moveable > moveablePair : ext::make_moveable_map(map)) {
		map2.insert(std::move(moveablePair));
	}

	bool res = map2.insert_or_assign ( MapTest::Moveable ( moves, copies ), MapTest::Moveable ( moves, copies ) ).second;

	CPPUNIT_ASSERT ( res == false );

	CPPUNIT_ASSERT(copies == 0);
}

