#ifndef TREE_TEST_H_
#define TREE_TEST_H_

#include <cppunit/extensions/HelperMacros.h>
#include <alib/compare>
#include <alib/tree>

class TreeTest : public CppUnit::TestFixture {
	CPPUNIT_TEST_SUITE ( TreeTest );
	CPPUNIT_TEST ( testTreeStdStructure );
	CPPUNIT_TEST_SUITE_END ( );

public:
	struct RankedArityChecker {
		bool operator ()( char symbol, unsigned wantedRank ) const {
			switch ( symbol ) {
			case 'a':
				return wantedRank == 2;

			case 'b':
				return wantedRank == 1;

			default:
				return wantedRank == 0;
			}
		}

	};

	void print_tree ( const ext::tree < char > & tree, std::string indent );

	void setUp ( );
	void tearDown ( );

	void testTreeStdStructure();
};

#endif // TREE_TEST_H_
