/*
 * LeftLG.h
 *
 * Created on: Sep 27, 2017
 * Author: Jan Travnicek
 */

#ifndef _STRING_LEFT_LG_H_
#define _STRING_LEFT_LG_H_

#include <grammar/Regular/LeftLG.h>
#include <core/stringApi.hpp>

#include <grammar/GrammarFromStringLexer.h>

#include <grammar/string/common/GrammarFromStringParserCommon.h>
#include <grammar/string/common/GrammarToStringComposerCommon.h>

namespace core {

template<class SymbolType >
struct stringApi < grammar::LeftLG < SymbolType > > {
	static grammar::LeftLG < SymbolType > parse ( std::istream & input );
	static bool first ( std::istream & input );
	static void compose ( std::ostream & output, const grammar::LeftLG < SymbolType > & grammar );
};

template<class SymbolType >
grammar::LeftLG < SymbolType > stringApi < grammar::LeftLG < SymbolType > >::parse ( std::istream & input ) {
	grammar::GrammarFromStringLexer::Token token = grammar::GrammarFromStringLexer::next(input);
	if(token.type != grammar::GrammarFromStringLexer::TokenType::LEFT_LG)
		throw exception::CommonException("Unrecognised LeftLG token.");

	return grammar::GrammarFromStringParserCommon::parseCFLikeGrammar < grammar::LeftLG < SymbolType > > ( input );
}

template<class SymbolType >
bool stringApi < grammar::LeftLG < SymbolType > >::first ( std::istream & input ) {
	grammar::GrammarFromStringLexer::Token token = grammar::GrammarFromStringLexer::next ( input );
	bool res = token.type == grammar::GrammarFromStringLexer::TokenType::LEFT_LG;
	grammar::GrammarFromStringLexer::putback ( input, token );
	return res;
}

template<class SymbolType >
void stringApi < grammar::LeftLG < SymbolType > >::compose ( std::ostream & output, const grammar::LeftLG < SymbolType > & grammar ) {
	output << "LEFT_LG";
	grammar::GrammarToStringComposerCommon::composeCFLikeGrammar ( output, grammar );
}

} /* namespace core */

#endif /* _STRING_LEFT_LG_H_ */
