/*
 * AnyObject.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef _XML_ANY_OBJECT_H_
#define _XML_ANY_OBJECT_H_

#include <object/AnyObject.h>
#include <core/xmlApi.hpp>

namespace core {

template < typename T >
struct xmlApi < object::AnyObject < T > > {
	static object::AnyObject < T > parse ( ext::deque < sax::Token >::iterator & input );
	static bool first ( const ext::deque < sax::Token >::const_iterator & input );
	static const std::string & xmlTagName ( );
	static void compose ( ext::deque < sax::Token > & output, const object::AnyObject < T > & data );
};

template < typename T >
object::AnyObject < T > xmlApi < object::AnyObject < T > >::parse ( ext::deque < sax::Token >::iterator & input ) {
	return object::AnyObject < T > ( core::xmlApi < T >::parse ( input ) );
}

template < typename T >
bool xmlApi < object::AnyObject < T > >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return core::xmlApi < T >::first ( input );
}

template < typename T >
const std::string & xmlApi < object::AnyObject < T > >::xmlTagName ( ) {
	return core::xmlApi < T >::xmlTagName ( );
}

template < typename T >
void xmlApi < object::AnyObject < T > >::compose ( ext::deque < sax::Token > & output, const object::AnyObject < T > & input ) {
	core::xmlApi < T >::compose ( output, input.getData ( ) );
}

} /* namespace core */

#endif /* _XML_ANY_OBJECT_H_ */
